'+--------------------------------------------------------------------------+
'|                                 Boing                                    |
'|                                                                          |
'|             Example of 32-bit OpenGL layered splash screen               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-10-2008 (MM-DD-YYYY)            |
'|                        Last revised : 10-10-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "Boing.exe"

#INCLUDE "GLDrawDIB.inc"
#RESOURCE "Boing.pbr"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

'------------------------------------------------------------------------------------------
' LOCAL section
'-----------------------------------------------------------------------------------------
%FRAME_SizeX = 200 '// The animation frame width
%FRAME_SizeY = 200 '// The animation frame height
%TIMER_DELAY = 20  '// The timer delay (animation speed)
%MOVE_STEP   = 8   '// The xPos, yPos step to move the window

GLOBAL gnCtrl, hGLDC, hGLRC, Img AS LONG
GLOBAL mt() AS BBPTEXTURE
GLOBAL xDir, yDir, xPos, yPos AS LONG
GLOBAL gSphere As LONG

FUNCTION GLsphere() AS LONG
    LOCAL ListID AS LONG
    ListID = glGenLists(1)
    CALL glNewList(ListID, %GL_COMPILE)

    CALL glEnable (%GL_TEXTURE_2D)
    CALL glBindTexture (%GL_TEXTURE_2D, mt(1).Texture)
    CALL DrawSphere()
    CALL glDisable (%GL_TEXTURE_2D)
  
  
    CALL glEndList()

  FUNCTION = ListID
END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEX
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS DWORD

'
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZAEROGL"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(GetModuleHandle(""), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = GetModuleHandle("")
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

'   // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = %WS_EX_LAYERED OR %WS_EX_TOPMOST OR %WS_EX_TOOLWINDOW

     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %FRAME_SizeX, %FRAME_SizeY)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       xPos = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       yPos = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              xPos, yPos, _           ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

'         // The OpenGL stuff
          CALL CreateGLcontext(rc.nRight - rc.nLeft, rc.nBottom - rc.nTop, hGLDC, hGLRC)
          DIM mt(1 TO 1) AS BBPTEXTURE
          mt(1).FullName = EXE.Path$ + "Boing.png":    mt(1).ID = 1: mt(1).Square = 0
          'mt(2).FullName = EXE.Path$ + "Boing0.png":   mt(2).ID = 2: mt(2).Square = 0

          CALL MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)
          CALL PlayWav()

gSphere = GLsphere()
          CALL ShowWindow(hMain, %SW_SHOW)

          CALL SetTimer(hMain, 1, %TIMER_DELAY, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND
          CALL KillTimer(hMain, 1)
CALL glDeleteLists(gSphere, 1)

          '//FreeUp resources
          IF Img THEN CALL GdipDisposeImage(Img): Img = 0
          CALL DestroyGLresources(hGLDC, hGLRC)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg
        
    CASE %WM_KEYDOWN
         IF wParam = &H1B& THEN '// VK_ESCAPE
            CALL DestroyWindow(hWnd)
         END IF
         
    CASE %WM_TIMER
         CALL SetImage(hWnd)
         
    CASE %WM_NCHITTEST
         FUNCTION = %HTCAPTION: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

%SND_RESOURCE       = &H40004     ' name is a resource name or atom
%SND_ASYNC          = &H1         ' play asynchronously
SUB PlayWav()
'   // Better to load from resource instead of file to limit CPU usage.
'    CALL Playsound((EXE.Path$ + "Boing.wav"), 0&, &H1)
    CALL Playsound("blup", GetModuleHandle(""), %SND_RESOURCE OR %SND_ASYNC)
END SUB

SUB SetImage(BYVAL hWnd AS LONG)
    LOCAL graphics, DesktopDC, x, y, ImgAttr AS LONG
    LOCAL rw AS RECT
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL lpSize AS SIZEL
    
    LOCAL hBmp, hMemDC AS LONG

    STATIC imgW, imgH AS LONG
      
    CALL GetWindowRect(hWnd, rw)
    lpSize.Cx = rw.nRight - rw.nLeft: lpSize.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop

    DesktopDC = GetDC(0)
    
    '// Create our memory DC
    hMemDC = CreateCompatibleDC(DesktopDC)
    hBmp = zCreateDIBSection(DesktopDC, lpSize.Cx, lpSize.CY, 32)
    IF hBmp THEN
       CALL SelectObject(hMemDC, hBmp)
       
       IF Img = 0 THEN
          CALL GdipLoadImageFromFile((UCODE$(EXE.Path$ + "Shadow.png")), Img)
          IF Img THEN CALL zGetImageSize(Img, imgW, imgH)
       END IF
       
'      // Draw the OpenGL scene
       CALL DrawTheScene()
       CALL wglMakeCurrent(hGLDC, hGLRC)
       CALL SwapBuffers(hGLDC)
       CALL DrawAndSetupAlphaChannel(hMemDC, -13, -14)
      
       IF Img THEN
          IF GdipCreateFromHDC(hMemDC, graphics) = 0 THEN
             CALL GdipSetInterpolationMode(graphics, 2)
             CALL GdipDrawImageRectRectI(graphics, Img, 1, 14, imgW, imgH, 0, 0, imgW, imgH, 2, ImgAttr)
             CALL GdipDeleteGraphics(graphics)
          END IF
       END IF    
      
'      // Update the layered window    
       bf.BlendOp             = %AC_SRC_OVER
       bf.BlendFlags          = 0
       bf.AlphaFormat         = %AC_SRC_ALPHA '// Use source alpha
       bf.SourceConstantAlpha = 255 '//alpha
       CALL UpdateLayeredWindow (hWnd, DesktopDC, lp, lpSize, hMemDC, ptSrc, 0, bf, %ULW_ALPHA)
      
       CALL DeleteObject(hBmp)
       CALL DeleteDC(hMemDC)     
      
'      //Move our window around the screen
       IF xDir = 0 THEN xDir = %MOVE_STEP: yDir = %MOVE_STEP
       IF xDir > 0 THEN
          IF xPos + %FRAME_SizeX - 21 > GetSystemMetrics(%SM_CXSCREEN) THEN xDir = -xDir: CALL PlayWav()
       ELSEIF xPos < 0 THEN 
          xDir = -xDir: CALL PlayWav()
       END IF
       IF yDir > 0 THEN
          IF yPos + %FRAME_SizeY - 21 > GetSystemMetrics(%SM_CYSCREEN) THEN yDir = -yDir: CALL PlayWav()
       ELSEIF yPos < 0 THEN 
          yDir = -yDir: CALL PlayWav()
       END IF
       xPos = xPos + xDir: yPos = yPos + yDir
       CALL MoveWindow(hWnd, xPos, yPos, %FRAME_SizeX, %FRAME_SizeY, 0)
    
    END IF
    CALL ReleaseDC(0, DesktopDC)
END SUB

SUB DrawSphere()
    LOCAL quadObj AS LONG
    quadObj = gluNewQuadric()                        ' Pointer to the Quadric Object (Return 0 If No Memory))
    IF quadObj THEN
       CALL gluQuadricNormals(quadObj, %GLU_SMOOTH)  ' Create Smooth Normals
       CALL gluQuadricTexture(quadObj, %GL_TRUE)     ' Create Texture Coords
       CALL gluSphere(quadObj, 0.95, 32, 32)
       CALL gluDeleteQuadric(quadObj)
    END IF
END SUB

SUB DrawTheScene() ' See MSDN documentation for the use of the OpenGL API
    STATIC xrot AS SINGLE, yrot AS SINGLE, zrot AS SINGLE

    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

'  ' Draw background image -----------------------------------------
'    CALL glDisable(%GL_LIGHT0)                                     ' Enable Light ZERO
'    CALL glDisable(%GL_LIGHTING)                                   ' Enable Lighting
'    CALL glDisable(%GL_COLOR_MATERIAL)                             ' Enable Coloring Of Material
'    CALL glBindTexture(%GL_TEXTURE_2D, mt(2).Texture)
'    CALL glBegin(%GL_QUADS)
'       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-16,-16,-70.0) ' Bottom Left Of The Texture And Quad
'       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 16,-16,-70.0) ' Bottom Right Of The Texture And Quad
'       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 16, 16,-70.0) ' Top Right Of The Texture And Quad
'       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-16, 16,-70.0) ' Top Left Of The Texture And Quad
'    CALL glEnd()
'  ' ----------------------------------------------------------------
'    CALL glEnable(%GL_LIGHT0)                                      ' Enable Light ZERO
'    CALL glEnable(%GL_LIGHTING)                                    ' Enable Lighting
'    CALL glEnable(%GL_COLOR_MATERIAL)                              ' Enable Coloring Of Material

'    CALL glPushMatrix()
'         CALL glColor4ub(255,255,255,255)
'    CALL glBindTexture(%GL_TEXTURE_2D, mt(2).Texture)
'    LOCAL quadObj AS LONG
'    quadObj = gluNewQuadric()                        ' Pointer to the Quadric Object (Return 0 If No Memory))
'    IF quadObj THEN
'       CALL gluQuadricNormals(quadObj, %GLU_SMOOTH)  ' Create Smooth Normals
'       CALL gluQuadricTexture(quadObj, %GL_TRUE)     ' Create Texture Coords
'       CALL gluSphere(quadObj, 0.92, 32, 32)
'       CALL gluDeleteQuadric(quadObj)
'    END IF
'    CALL glPopMatrix()


    CALL glPushMatrix()
         CALL glTranslatef(0.0, 0.0, -5.26) 
         CALL glRotatef(xrot, 1.0, 0.0, 0.0)                       ' Rotate On The X Axis
         CALL glRotatef(yrot, 0.0, 1.0, 0.0)                       ' Rotate On The Y Axis
         CALL glRotatef(zrot, 0.0, 0.0, 1.0)                       ' Rotate On The Z Axis

         xrot = xrot + 0.6 * RND(3,6) ' X Axis Rotation
         yrot = yrot + 0.4 * RND(3,6) ' Y Axis Rotation
         zrot = zrot + 0.8 * RND(4.6) ' Z Axis Rotation

         CALL glColor4ub(255,255,255,255)

         '//CALL glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)
         '//CALL DrawSphere()
         CALL glCallList(gSphere)
    CALL glPopMatrix()


END SUB

FUNCTION Rgb2Gray ALIAS "Rgb2Gray" (BYVAL RGBValue AS DWORD) EXPORT AS DWORD

    !XOR ESI, ESI
    !XOR EDX, EDX
    !MOV ECX, RGBValue

  ' Red
    !MOV EAX, 19595
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Green
    !MOV EAX, 38470
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Blue
    !MOV EAX, 7471
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    !SHR ESI, 16
    !MOV EDX, ESI

  ' Put Gray Value to a DWORD (0GGG)
    !XOR EAX, EAX
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL

    !MOV FUNCTION, EAX

END FUNCTION

SUB DrawAndSetupAlphaChannel(BYVAL hMemDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG)
'   // We must do this to be compatible with BitBlt
'   // We compute a fake alpha channel based on color conversion to shade of gray
    LOCAL pBits AS BYTE PTR, bm AS BITMAP, P AS LONG
    CALL GetObject(GetCurrentObject(hGLDC, 7), SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
        Alpha& = Rgb2Gray(RGB(@pBits[2],@pBits[1],@pBits[0])) AND &H000000FF???
        '@pBits[3] = MIN&(Alpha& * 255, 255)
        IF Alpha& = 0 THEN
           @pBits[3] = 0
        ELSE
           @pBits[3] = 255
        END IF
        pBits = pBits + 4
    NEXT
    CALL BitBlt(hMemDC, x, y, bm.bmWidth, bm.bmHeight, hGLDC, 0, 0, %SRCCOPY)
END SUB

FUNCTION zSetupPixelFormat(BYVAL hDC AS LONG) AS LONG
    LOCAL pfd AS PIXELFORMATDESCRIPTOR
    LOCAL pixelformat AS LONG
    LOCAL lRet AS LONG

    lRet = %TRUE

    pfd.nSize      = SIZEOF(pfd)
    pfd.nVersion   = 1
    pfd.dwFlags    = %PFD_SUPPORT_OPENGL OR %PFD_DRAW_TO_BITMAP ' OR %PFD_SUPPORT_GDI
    pfd.iPixelType = %PFD_TYPE_RGBA

    pfd.cColorBits = 32
    pfd.cDepthBits = 32

    pixelformat = ChoosePixelFormat(hDC, pfd)

    IF pixelformat THEN
       IF SetPixelFormat(hDC, pixelformat, pfd) = 0 THEN lRet = %FALSE
    ELSE
       lRet = %FALSE
    END IF

    FUNCTION = lRet
END FUNCTION

FUNCTION CreateGLcontext(BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYREF hGLDC AS LONG, BYREF hGLRC AS LONG) AS LONG
    LOCAL nRet, DesktopDC, hGLBMP AS LONG
    IF nWidth > 0 AND nHeight > 0 THEN
       DesktopDC = GetDC(0)
       hGLDC = CreateCompatibleDC(DesktopDC)
       hGLBMP = zCreateDIBSection(DesktopDC, nWidth, nHeight, 32)
       CALL SelectObject(hGLDC, hGLBMP)
       CALL ReleaseDC(0, DesktopDC)
       IF hGLBMP THEN
          IF zSetupPixelFormat(hGLDC) THEN
            hGLRC = wglCreateContext(hGLDC)
            IF hGLRC THEN
               IF wglMakeCurrent(hGLDC, hGLRC) THEN
   
                  CALL glClearColor(0.0, 0.0, 0.0, 0.0)
                  CALL glClearDepth(1.0)
                  CALL glDepthFunc(%GL_LESS)'GREATER)'LEQUAL)'ALWAYS)
                  CALL glEnable(%GL_DEPTH_TEST)
                  CALL glShadeModel(%GL_SMOOTH)

                  CALL glMatrixMode(%GL_MODELVIEW)'%GL_PROJECTION)

                  CALL glViewport(0, 0, nWidth, nHeight)

                  CALL glEnable(%GL_TEXTURE_2D)

'                 // Use alphablending
                  CALL glEnable(%GL_BLEND)
                  CALL glBlendFunc(%GL_SRC_ALPHA, %GL_ONE_MINUS_SRC_ALPHA)


                  DIM LightAmbient(3) AS SINGLE:  ARRAY ASSIGN LightAmbient()  = 0.05, 0.05, 0.05, 1.0
                  DIM LightDiffuse(3) AS SINGLE:  ARRAY ASSIGN LightDiffuse()  = 0.6, 0.6, 0.6, 0.1
                  DIM LightPosition(3) AS SINGLE: ARRAY ASSIGN LightPosition() = -0.20, 0.20, 0.20, 0.7
                  CALL glLightfv(%GL_LIGHT0, %GL_AMBIENT, LightAmbient(0))      ' Setup The Ambient Light
                  CALL glLightfv(%GL_LIGHT0, %GL_DIFFUSE, LightDiffuse(0))      ' Setup The Diffuse Light
                  CALL glLightfv(%GL_LIGHT0, %GL_POSITION, LightPosition(0))    ' Position The Light
                  CALL glEnable(%GL_LIGHT0)                                     ' Enable Light ZERO
                  CALL glEnable(%GL_LIGHTING)                                   ' Enable Lighting
                  CALL glEnable(%GL_COLOR_MATERIAL)                             ' Enable Coloring Of Material


                  CALL gluPerspective(24, 1.0, 1.0, 100.0)

                  nRet = -1
                 
               END IF
            END IF
          END IF
       END IF
    END IF
    FUNCTION = nRet
END FUNCTION

SUB DestroyGLresources(BYREF hGLDC AS LONG, BYREF hGLRC AS LONG)
    IF hGLRC THEN
       CALL wglMakeCurrent(hGLDC, 0)
       CALL wglDeleteContext(hGLRC): hGLRC = 0
    END IF
    IF hGLDC THEN
       CALL DeleteObject(GetCurrentObject(hGLDC, %OBJ_BITMAP)) ' Delete the memory bitmap
       CALL DeleteDC(hGLDC): hGLDC = 0
    END IF
END SUB

